<template>
  <q-page padding>
    <q-toolbar class="bg-blue-grey text-white shadow-2 rounded-borders">
      Gestion de Permisos: &nbsp;
      <q-space />
      <div class="q-gutter-xs">
        <q-btn
          flat
          dense
          icon="arrow_back_ios_new"
          label="Atras"
          href="javascript:history.go(-1)"
        />
      </div>
    </q-toolbar>
    <br />
    <q-markup-table>
      <thead>
        <tr>
          <th>Funcion</th>
          <th>Permisos</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="funcion in dataSetFunciones" :key="funcion.id">
          <td>{{ funcion.nombre }}</td>
          <td>
            <div class="q-gutter-xs row truncate-chip-labels">
              <template v-for="permiso in dataSetPermisos" :key="permiso.id">
                <q-chip
                  v-if="
                    funcion.acl_permisos_personas_funciones.find(
                      (value) => value.acl_permisos_id === permiso.id
                    )
                  "
                  color="green"
                  text-color="white"
                  size="sm"
                  icon="done"
                  clickable
                  @click="permisoQuitar(funcion.id, permiso.id)"
                >
                  {{ permiso.nombre }}
                </q-chip>

                <q-chip
                  v-else
                  size="sm"
                  text-color="white"
                  clickable
                  @click="permisoAgregar(funcion.id, permiso.id)"
                >
                  {{ permiso.nombre }}
                </q-chip>
              </template>
            </div>
          </td>
        </tr>
      </tbody>
    </q-markup-table>

    <Loading :showing="loading" />
  </q-page>
</template>
<style lang="sass" scoped>
.truncate-chip-labels > .q-chip
  max-width: auto
</style>

<script lang="ts">
import { defineComponent, ref, onMounted } from 'vue';
import Loading from 'src/components/Loading.vue';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
export default defineComponent({
  name: 'IndexPage',
  components: { Loading },
  setup() {
    const loading = ref(false);

    onMounted(() => {
      getPermisos();
      getFunciones();
    });

    const dataSetPermisos = ref([]);

    function getPermisos() {
      loading.value = true;
      api
        .get('/api/administrador/usuarios/permisos/permisos')
        .then((response: AxiosResponse) => {
          dataSetPermisos.value = response.data;
          loading.value = false;
        })
        .catch(() => {
          loading.value = false;
        });
    }

    const dataSetFunciones = ref([]);

    function getFunciones() {
      loading.value = true;
      api
        .get('/api/administrador/usuarios/permisos/funciones')
        .then((response: AxiosResponse) => {
          dataSetFunciones.value = response.data;
          loading.value = false;
        })
        .catch(() => {
          loading.value = false;
        });
    }

    function permisoAgregar(FuncionId: number, PermisoId: number) {
      loading.value = true;

      api
        .post('/api/administrador/usuarios/permisos/permisos', {
          acl_funcion_id: FuncionId,
          acl_permisos_id: PermisoId,
        })
        .then(() => {
          getFunciones();
        });
    }
    function permisoQuitar(FuncionId: number, PermisoId: number) {
      loading.value = true;
      api
        .delete('/api/administrador/usuarios/permisos/permisos', {
          data: {
            acl_funcion_id: FuncionId,
            acl_permisos_id: PermisoId,
          },
        })
        .then(() => {
          getFunciones();
        });
    }

    return {
      loading,
      dataSetFunciones,
      dataSetPermisos,
      permisoAgregar,
      permisoQuitar,
    };
  },
});
</script>
